#!/usr/bin/env python
#fileencoding: utf-8
#Author: Liu DongMiao <liudongmiao@gmail.com>
#Created  : Mon 11 Apr 2011 10:45:03 PM CST

BACKUP = {
    'ca.crt': '/etc/openvpn/ca.crt',
    'client.conf': '/etc/openvpn/client.conf',
    'client.crt': '/etc/openvpn/client.crt',
    'client.key': '/etc/openvpn/client.key',
    'device': '/etc/nas/device',
    'exports': '/etc/exports',
    'fstab': '/etc/fstab',
    'htdigest': '/etc/nas/htdigest',
    'ifcfg-eth0': '/etc/sysconfig/network-scripts/ifcfg-eth0',
    'mdadm.conf': '/etc/mdadm.conf',
    'minidlna.conf': '/etc/minidlna.conf',
    'mt-daapd.conf': '/etc/mt-daapd.conf',
    'network': '/etc/sysconfig/network',
    'ntp.conf': '/etc/ntp.conf',
    'passwd': '/etc/passwd',
    'shadow': '/etc/shadow',
    'smb.conf': '/etc/nas/smb.conf',
    'smbpasswd': '/etc/nas/smbpasswd',
    'smtp': '/etc/nas/smtp',
    'spindown': '/etc/nas/spindown',
    'vsftpd.conf': '/etc/nas/vsftpd.conf',
    'anonftp': '/etc/nas/anonftp',
    'localtime': '/etc/localtime',
    }

import os
import zipfile
from system import _makesure_dir
from system import NASError

def backup(zipname):
    ZIP = zipfile.ZipFile(zipname, 'w')
    for name in BACKUP:
        if os.path.exists(BACKUP[name]):
            ZIP.write(BACKUP[name], name)
    ZIP.close()

PATH = '/var/cache/nas/restore'
def restore(zipname):
    ZIP = zipfile.ZipFile(zipname, 'r')
    members = []
    needsize = 0
    for info in ZIP.infolist():
        name = os.path.split(info.filename)[1]
        if name in BACKUP.keys():
            members.append(info)
            needsize += info.file_size

    if needsize:
        statvfs = os.statvfs('/')
        if statvfs.f_bavail * statvfs.f_bsize < needsize:
            raise NASError('no enough space')

    _makesure_dir(PATH)
    ZIP.extractall(PATH, members)

if __name__ == '__main__':
    backup('/tmp/backup.zip')
    restore('/tmp/backup.zip')

# vim: set sta sw=4 et:
