#!/usr/bin/env python
#fileencoding: utf-8
#Author: Liu DongMiao <liudongmiao@gmail.com>
#Created  : Wed 12 May 2010 03:38:08 PM CST

''' Samba '''

from service import *
from system import get_name_value
from system import set_name_value
from nas import check_public

SAMBACONF = '/etc/nas/smb.conf'
REALSAMBACONF = '/etc/samba/smb.conf'


def setsmb(enable=None, workgroup=None, **kw):
    if enable is None:
        enable = servicestatus('smb')
    else:
        enable = str(enable)

    if workgroup:
        names = {'workgroup': '%s' % workgroup}
        set_name_value(SAMBACONF, names)

    os.unlink(REALSAMBACONF)
    os.symlink(SAMBACONF, REALSAMBACONF)

    check_public()
    if enable == 'yes':
        enableservice('smb')
        enableservice('nmb')
        restartservice('smb', 'smbd', 139)
        restartservice('nmb', 'nmbd')
    else:
        disableservice('smb')
        disableservice('nmb')
        stopservice('smb')
        stopservice('nmb')
    return getsmb()

def getsmb(**kw):
    names = {'workgroup': None}
    get_name_value(SAMBACONF, names)
    names['enable'] = servicestatus('smb')
    names['running'] = servicerunning('smbd', 139)
    return names

__all__ = ['getsmb', 'setsmb']

# vim: set sta sw=4 et:
